﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace MvcAreas.App
{
    public class AreaControllerFactory : DefaultControllerFactory
    {
        protected override Type GetControllerType(string controllerName)
        {
            object areaName;
            if (RequestContext != null && RequestContext.RouteData.Values.TryGetValue("area", out areaName))
            {
                string ns = string.Empty;
                switch (areaName.ToString().Trim().ToLower())
                {
                    case "common":
                        ns = "MvcAreas.App.Controllers.Common";
                        break;
                    case "catalog":
                        ns = "MvcAreas.App.Controllers.Catalog";
                        break;
                    case "forum":
                        ns = "MvcAreas.App.Controllers.Forum";
                        break;
                }
                if (ns.Length > 0)
                    return Type.GetType(ns + "." + controllerName + "Controller");
            }
            return base.GetControllerType(controllerName);
        }
    }
}
